#!/bin/sh

# Set Mail Address and URL
my_mail="yourmail@example.net"
my_url="http://www.example.net/GNS/"

# Set Program Path
path_perl=`which perl`
path_nkf=`which nkf`
path_mail=`which mail`
# path_perl='/usr/local/bin/perl'
# path_nkf='/usr/local/bin/nkf'
# path_mail='/usr/bin/mail'

# Set Replace source
orig_my_mail="yourmail@example.net"
orig_my_url="http://www.example.net/GNS/"
orig_path_perl='/usr/local/bin/perl'
orig_path_nkf='/usr/local/bin/nkf'
orig_path_mail='/usr/bin/mail'

# Display Replace data
echo "[Welcome to GNS!]"
echo "-------------------------------------------------"
echo "Your Mail Address = [${my_mail}]"
echo "Your Diary URL    = [${my_url}]"
echo "perl              = [${path_perl}]"
echo "nkf               = [${path_nkf}]"
echo "mail              = [${path_mail}]"
echo "-------------------------------------------------"
echo "Push [Enter] key to continue installation."
read ok

# Extract Archive
echo "Extract archive gns.tar..."
tar xvf gns.tar
echo "Finish extracting archive."

# Set GNS Folder's permission
chmod 0777 ..

# Create tmp folder
echo "-------------------------------------------------"
if [ ! -d tmp ]; then
  echo "Create folder [tmp/]"
  mkdir tmp
fi
chmod 0777 tmp

# Create Diary Master Folder
echo "-------------------------------------------------"
if [ ! -d ../d ]; then
  echo "Create folder [../d/]"
  mkdir ../d
fi
if [ ! -d ../d/keep ]; then
  echo "Create folder [../d/keep/]"
  mkdir ../d/keep
fi
chmod 0777 ../d
chmod 0777 ../d/keep
cd keep
for FILE in *.html
do
  if [ ! -f ../../d/keep/$FILE ]; then
    echo "Copy database [../d/keep/$FILE]"
    cp $FILE ../../d/keep/
    chmod 0666 ../../d/keep/$FILE
  fi
done
cd ..

# Create Picture Folder
echo "-------------------------------------------------"
if [ ! -d ../pic ]; then
  echo "Create picture folder [../pic/]"
  mkdir ../pic
fi
chmod 0777 ../pic

# Create TB/CM Folder
echo "-------------------------------------------------"
if [ ! -d ../tb ]; then
  echo "Create TB/CM folder [../tb/]"
  mkdir ../tb
fi
if [ ! -d ../tb/log ]; then
  echo "Create TB/CM log folder [../tb/log/]"
  mkdir ../tb/log
fi
chmod 0777 ../tb
chmod 0777 ../tb/log
if [ ! -f ../tb/index.html ]; then
  touch ../tb/index.html
fi
if [ ! -f ../tb/log/index.html ]; then
  touch ../tb/log/index.html
fi

# Replace Program Path
echo "-------------------------------------------------"
rm tmp/* >/dev/null
cp *.sh *.cgi *.pl *.ph tmp/
cd tmp
rm install*.*
echo "s+${orig_path_perl}+${path_perl}+" >../replace.sed
echo "s+${orig_path_nkf}+${path_nkf}+" >>../replace.sed
echo "s+${orig_path_mail}+${path_mail}+" >>../replace.sed
echo "s+${orig_my_mail}+${my_mail}+" >>../replace.sed
echo "s+${orig_my_url}+${my_url}+" >>../replace.sed
# cat ../replace.sed
for FILE in *.*
do
  echo "Replace file [./$FILE]"
  sed -f ../replace.sed $FILE>../$FILE
done
if [ ! -f ../config.ph ]; then
  echo "Create configure file [./config.ph]"
  cp ../config_sample.ph ../config.ph
fi
if [ ! -f ../config2.ph ]; then
  echo "Create configure file [./config2.ph]"
  cp ../config2_sample.ph ../config2.ph
fi
rm ../replace.sed
cd ..

rm tmp/* >/dev/null
echo "-------------------------------------------------"
cp tb/*.cgi tb/*.ph tb/*.txt tmp/
cd tmp
echo "s+${orig_path_perl}+${path_perl}+" >../replace.sed
echo "s+${orig_path_nkf}+${path_nkf}+" >>../replace.sed
echo "s+${orig_path_mail}+${path_mail}+" >>../replace.sed
echo "s+${orig_my_mail}+${my_mail}+" >>../replace.sed
echo "s+${orig_my_url}+${my_url}+" >>../replace.sed
# cat ../replace.sed
for FILE in *.*
do
  echo "Replace file [../tb/$FILE]"
  sed -f ../replace.sed $FILE>../../tb/$FILE
done
if [ ! -f ../../tb/tb.ph ]; then
  echo "Create configure file [../tb/tb.ph]"
  cp ../../tb/tb_sample.ph ../../tb/tb.ph
fi
if [ ! -f ../../tb/config.ph ]; then
  echo "Create configure file [../tb/config.ph]"
  cp ../../tb/config_sample.ph ../../tb/config.ph
fi
if [ ! -f ../../tb/cmfilter.txt ]; then
  echo "Create filter file [../tb/cmfilter.txt]"
  cp ../../tb/cmfilter_sample.txt ../../tb/cmfilter.txt
fi
if [ ! -f ../../tb/tbfilter.txt ]; then
  echo "Create filter file [../tb/tbfilter.txt]"
  cp ../../tb/tbfilter_sample.txt ../../tb/tbfilter.txt
fi
rm ../replace.sed
cd ..

rm tmp/* >/dev/null

# Set Program permission
chmod 0755 *.cgi
chmod 0755 *.sh
chmod 0755 ../tb/*.cgi

echo "-------------------------------------------------"
echo "Installation finished."
